#
# SNiFF+ - Makefile configuration for Rtems
#

# RTEMS BSP Path
RTEMS_BSP_NAME = cpu2000
RTEMS_BSP_PATH = /opt/rtems/bsp-$(RTEMS_BSP_NAME)
RTEMS_MAKEFILE_PATH = $(RTEMS_BSP_PATH)/m68k-rtems/$(RTEMS_BSP_NAME)
RTEMS_LIB_PATH = $(RTEMS_MAKEFILE_PATH)/lib

export RTEMS_MAKEFILE_PATH

# Native platform definition
NATIVE_PLATFORM	:=	$(shell sniff_arch;)

# First include the native platform definition
include $(SNIFF_DIR)/make_support/$(NATIVE_PLATFORM).mk

# Now cutomize for Rtems use

CC_FOR_TARGET = m68k-rtems-gcc --pipe
AR_FOR_TARGET = m68k-rtems-ar
LD_FOR_TARGET = m68k-rtems-ld
CXX_FOR_TARGET = m68k-rtems-g++

# C++ compiler
CXX 		= 	$(CXX_FOR_TARGET)
CXXFLAGS 	= 	-B$(RTEMS_LIB_PATH) -specs bsp_specs -qrtems -g -Wall -O4 -fomit-frame-pointer -g -m68000

# C compiler
CC 		= 	$(CC_FOR_TARGET)
CFLAGS 		= 	-B$(RTEMS_LIB_PATH) -specs bsp_specs -qrtems -g -Wall -O4 -fomit-frame-pointer -g -m68000

# program for linking an executable
LINK 		= 	$(CXX)
LINKCMDS	=	$(RTEMS_LIB_PATH)/linkcmds

# program for linking relocatable object files
LD 		= 	$(LD_FOR_TARGET)
LDFLAGS  	= 

AR      	= 	$(AR_FOR_TARGET)
ARFLAGS 	= 	
RANLIB  	= 	true

# X11 include files and library (not available)
X11_INCL 	= 	
X11_LIB  	=	





