#
#	general.c.mk
#
#	SNiFF+ V3.0
#
#	Common make rules for c, c++ and pro*c/c++ compilers.
#
#	Copyright (C) 1998 TakeFive Software GmbH
#	Salzburg, Austria (e-mail: sniff@TakeFive.co.at)
#
#	Author: Sandor Korosi

CXX_OUTPUT_FLAG		= -o $@
CC_OUTPUT_FLAG		= -o $@
 
#        All C++ compiler flags and compiler command
ALL_CXXFLAGS = $(SNIFF_INCLUDE) $(OTHER_CXXFLAGS) $(COMMON_CXXFLAGS) $(OS_CXXFLAGS) $(CXXFLAGS) $(SNIFF_CFLAGS)
CXX_CMD = $(CXX) $(ALL_CXXFLAGS) $(OVERALL_OPTION_CXX) "$<" $(CXX_OUTPUT_FLAG)

#        All C compiler flags and compiler command
ALL_CFLAGS   = $(SNIFF_INCLUDE) $(OTHER_CFLAGS) $(COMMON_CFLAGS) $(OS_CFLAGS) $(CFLAGS) $(SNIFF_CFLAGS)
CC_CMD = $(CC) $(ALL_CFLAGS) $(OVERALL_OPTION_CC) "$<" $(CC_OUTPUT_FLAG)

#        All pro*c/c++ flags and compiler command
ALL_PROCFLAGS = $(OTHER_PROCFLAGS) $(COMMON_PROCFLAGS) $(OS_PROCFLAGS) $(PROCFLAGS)
PROC_CMD = $(PROC) $(ALL_PROCFLAGS) "$<"

#		All Windows Resouce Compiler Flags
ALL_WINRCFLAGS = $(SNIFF_INCLUDE) $(OTHER_WINRCFLAGS) $(COMMON_WINRCFLAGS) $(OS_WINRCFLAGS) $(WINRCFLAGS) 
WINRC_CMD = $(WINRC) $(ALL_WINRCFLAGS) -Fo$@ "$<"

REMOVE_GENERATED_C_FILE = 0

## ATTENTION Dont remove the ;  after the 2 following rules (empty rule)
#%.o : $(OBJECT_DIR)/%.o ; 
#%.res : $(OBJECT_DIR)/%.res ;
 
#       rules for C++ compiler
$(OBJECT_DIR)/%.o : $(SNIFF_Implementation_DIR)/%.C $(FORCE_RULE)
	@ d=`dirname '$@'`;\
	relative=`echo $$d | cut -d"/" -f1`;\
	if [ "$$d" != "." -a "$$d" != "$(OBJECT_DIR)" -a "$$relative" != "" ]; then\
		cd $$d;\
		echo make: Changing directory to \'$$d\';\
		$(OWN_MAKE) -f $(MAKEFILE) `basename '$@'`;\
	else\
		TARGET=$@; TARGET_TYPE="C++ object"; $(MAKE_TARGET);\
		if [ "$(DEBUG)" = "1" ]; then \
			echo "$(CXX_CMD)";\
		fi;\
		$(CXX_CMD);\
		ret=$$?;\
		if [ $(REMOVE_GENERATED_C_FILE) = 1 ]; then\
			echo "make: removing" "$<";\
			$(RM) "$<";\
		fi;\
		exit $$ret;\
	fi;

$(OBJECT_DIR)/%.o : $(SNIFF_Implementation_DIR)/%.cc $(FORCE_RULE)
	@ d=`dirname '$@'`;\
	relative=`echo $$d | cut -d"/" -f1`;\
	if [ "$$d" != "." -a "$$d" != "$(OBJECT_DIR)" -a "$$relative" != "" ]; then\
		cd $$d;\
		echo make: Changing directory to \'$$d\';\
		$(OWN_MAKE) -f $(MAKEFILE) `basename '$@'`;\
	else\
		TARGET=$@; TARGET_TYPE="C++ object"; $(MAKE_TARGET);\
		if [ "$(DEBUG)" = "1" ]; then \
			echo "$(CXX_CMD)";\
		fi;\
		$(CXX_CMD);\
		ret=$$?;\
		if [ $(REMOVE_GENERATED_C_FILE) = 1 ]; then\
			echo "make: removing" "$<";\
			$(RM) "$<";\
		fi;\
		exit $$ret;\
	fi;

$(OBJECT_DIR)/%.o : $(SNIFF_Implementation_DIR)/%.cxx $(FORCE_RULE)
	@ d=`dirname '$@'`;\
	relative=`echo $$d | cut -d"/" -f1`;\
	if [ "$$d" != "." -a "$$d" != "$(OBJECT_DIR)" -a "$$relative" != "" ]; then\
		cd $$d;\
		echo make: Changing directory to \'$$d\';\
		$(OWN_MAKE) -f $(MAKEFILE) `basename '$@'`;\
	else\
		TARGET=$@; TARGET_TYPE="C++ object"; $(MAKE_TARGET);\
		if [ "$(DEBUG)" = "1" ]; then \
			echo "$(CXX_CMD)";\
		fi;\
		$(CXX_CMD);\
		ret=$$?;\
		if [ $(REMOVE_GENERATED_C_FILE) = 1 ]; then\
			echo "make: removing" "$<";\
			$(RM) "$<";\
		fi;\
		exit $$ret;\
	fi

$(OBJECT_DIR)/%.o : $(SNIFF_Implementation_DIR)/%.cpp $(FORCE_RULE)
	@ d=`dirname '$@'`;\
	relative=`echo $$d | cut -d"/" -f1`;\
	if [ "$$d" != "." -a "$$d" != "$(OBJECT_DIR)" -a "$$relative" != "" ]; then\
		cd $$d;\
		echo make: Changing directory to \'$$d\';\
		$(OWN_MAKE) -f $(MAKEFILE) `basename '$@'`;\
	else\
		TARGET=$@; TARGET_TYPE="C++ object"; $(MAKE_TARGET);\
		if [ "$(DEBUG)" = "1" ]; then \
			echo "$(CXX_CMD)";\
		fi;\
		$(CXX_CMD);\
		ret=$$?;\
		if [ $(REMOVE_GENERATED_C_FILE) = 1 ]; then\
			echo "make: removing" "$<";\
			$(RM) "$<";\
		fi;\
		exit $$ret;\
	fi;

#       rule for C compiler
$(OBJECT_DIR)/%.o : $(SNIFF_Implementation_DIR)/%.c $(FORCE_RULE)
	@ d=`dirname '$@'`;\
	relative=`echo $$d | cut -d"/" -f1`;\
	if [ "$$d" != "." -a "$$d" != "$(OBJECT_DIR)" -a "$$relative" != "" ]; then\
		cd $$d;\
		echo make: Changing directory to \'$$d\';\
		$(OWN_MAKE) -f $(MAKEFILE) `basename '$@'`;\
	else\
		TARGET=$@; TARGET_TYPE="C object"; $(MAKE_TARGET);\
		if [ "$(DEBUG)" = "1" ]; then \
			echo "$(CC_CMD)";\
		fi;\
		$(CC_CMD);\
		ret=$$?;\
		if [ $(REMOVE_GENERATED_C_FILE) = 1 ]; then\
			echo "make: removing" "$<";\
			$(RM) "$<";\
		fi;\
		exit $$ret;\
	fi;

#	rule for pro*c/c++ compiler
$(OBJECT_DIR)/%.o : $(SNIFF_Implementation_DIR)/%.pc $(FORCE_RULE)
	@d=`dirname '$@'`;\
	relative=`echo $$d | cut -d"/" -f1`;\
	if [ "$$d" != "." -a "$$d" != "$(OBJECT_DIR)" -a "$$relative" != "" ]; then\
		cd $$d;\
		echo make: Changing directory to \'$$d\';\
		$(OWN_MAKE) -f $(MAKEFILE) `basename '$@'`;\
	else\
		TARGET=`basename $*$(PROCEXTENSION)`; TARGET_TYPE="preprocessed"; $(MAKE_TARGET);\
		if [ "$(DEBUG)" = "1" ]; then \
			echo "$(PROC_CMD)";\
		fi;\
		$(PROC_CMD);\
		ret=$$?;\
		if [ $$ret = 0 ]; then \
		if [ $(PROCDEBUG) = 0 ]; then \
			$(OWN_MAKE) -f $(MAKEFILE) '$@' REMOVE_GENERATED_C_FILE=1; \
		else \
			$(OWN_MAKE) -f $(MAKEFILE) '$@';\
		fi; \
		else\
			if [ $(REMOVE_GENERATED_C_FILE) = 1 ]; then\
				echo "make: removing bad" $$TARGET;\
				$(RM) $$TARGET;\
			fi;\
		fi; \
		exit $$ret;\
	fi;

#	rule for Windows Resource Compiler
$(OBJECT_DIR)/%.res : $(SNIFF_Implementation_DIR)/%.rc $(FORCE_RULE)
	@ d=`dirname '$@'`;\
	relative=`echo $$d | cut -d"/" -f1`;\
	if [ "$$d" != "." -a "$$d" != "$(OBJECT_DIR)" -a "$$relative" != "" ]; then\
		cd $$d;\
		echo make: Changing directory to \'$$d\';\
		$(OWN_MAKE) -f $(MAKEFILE) `basename '$@'`;\
	else\
		TARGET=$@; TARGET_TYPE="Windows Resource"; $(MAKE_TARGET);\
		if [ "$(DEBUG)" = "1" ]; then \
			echo "$(WINRC_CMD)";\
		fi;\
		$(WINRC_CMD);\
	fi;

clean_c :
	@for pcfile in $(SNIFF_Embedded_SQL_FILES); do\
		cfile=`echo $$pcfile | cut -d"." -f1`$(PROCEXTENSION);\
		echo "make: removing" $$cfile;\
		$(RM) $$cfile;\
	done
