#
#	general.obsolete.mk
#
#	SNiFF+ V3.0
#
#	Common obsolete help targets.
#
#	Copyright (C) 1998 TakeFive Software GmbH
#	Salzburg, Austria (e-mail: sniff@TakeFive.co.at)
#
#	Author: Sandor Korosi


#        Shell script to update files to those in repository and shared workspaces
UPDATE_FILE_SH = $(SNIFF_DIR)/bin/'sniffUpdateFile.$(SNIFF_VCS).sh'

########################################################################
# update_ws_to_repository
# 		update private files with respect to the repository files 
#		and to the shared files
########################################################################

update_ws_to_repository :: symbolic_links_to_makefiles touch_status_file

########################################################################
# update_ws_to_shared_ws
# 		update private files with respect to the shared files
########################################################################

update_ws_to_shared_ws :: symbolic_links_to_makefiles touch_status_file 

# touch status file
touch_status_file :
	@if [ "$(SNIFF_STATUSFILE)" != "" ]; then\
		echo make: Touching status file;\
		if [ $(DEBUG) != 0 ]; then\
			echo touch $(SNIFF_STATUSFILE);\
		fi;\
		touch $(SNIFF_STATUSFILE);\
	fi

########################################################################
# symbolic_links_to_source_files
# 		create symbolic links to the source files in the 
#		shared source working environment
########################################################################
symbolic_links_to_source_files :: _symbolic_links_to_source_files
_symbolic_links_to_source_files :
	-@ echo "*** $(PARENT)";\
	if [ "$(SNIFF_FILES)" != "" -a "$(SNIFF_ShSWS)" != "" ];then\
		if [ "$(MK_SYMLINK)" != "" ]; then\
			echo "make: creating symbolic links to shared source files in project '$(SNIFF_PROJECT)'";\
		else\
			echo "make: copying shared source files in project '$(SNIFF_PROJECT)'";\
		fi;\
		for f in _dummy_ $(SNIFF_FILES);do\
			if [ -h $$f ];then\
				if [ $(DEBUG) != 0 ]; then\
					echo make: $$f: removing symbolic link;\
				fi;\
				$(RM) $$f;\
			fi;\
			if [ ! -f $$f ];then\
				for dir in _dummy_ `echo "$(SNIFF_ShSWS)"|sed -e 's/$(D)/ /g'`;do\
					if [ $$dir = "_dummy_" ]; then\
						continue;\
					fi;\
					if [ -r $$dir/$$f ]; then\
						if [ $(DEBUG) != 0 ]; then\
							if [ "$(MK_SYMLINK)" != "" ]; then\
								echo make: $$f: creating symbolic link to shared source file;\
								echo $(MK_SYMLINK) $$dir/$$f $$f;\
							else\
								echo make: $$f: copying shared source file;\
								echo $(CP) -p $$dir/$$f $$f;\
							fi;\
						fi;\
						if [ "$(MK_SYMLINK)" != "" ]; then\
							$(MK_SYMLINK) $$dir/$$f $$f;\
						else\
							$(CP) -p $$dir/$$f $$f;\
						fi;\
						break;\
					fi;\
				done;\
			fi;\
		done;\
	fi

########################################################################
# clean_symbolic_links
# 		clean symbolic links to the source files in the 
#		privat working environment
########################################################################
# NOTE: this can also remove 'Makefile'
clean_symbolic_links :: _clean_symbolic_links symbolic_links_to_makefiles
_clean_symbolic_links :
	-@ echo "*** $(PARENT)";\
	if [ "$(SNIFF_FILES)" != "" ];then\
		if [ "$(MK_SYMLINK)" != "" ]; then\
			echo make: Removing symbolic links of the project \'$(SNIFF_PROJECT)\';\
		else\
			echo make: Removing copyied files of the project \'$(SNIFF_PROJECT)\';\
		fi;\
		for f in _dummy_ $(SNIFF_FILES);do\
			if [ "$(MK_SYMLINK)" != "" ]; then\
				if [ -h $$f ];then\
					if [ $(DEBUG) != 0 ]; then\
						echo $(RM) $$f;\
					fi;\
					$(RM) $$f;\
				fi;\
			else\
				if [ -r $$f -a ! -w $$f ]; then\
					for dir in _dummy_ `echo "$(SNIFF_ShSWS)" | sed -e 's/$(D)/ /g'`; do\
						if [ $$dir = "_dummy_" ]; then\
							continue;\
						fi;\
						if [ -r $$dir/$$f ]; then\
							cmp -s $$dir/$$f $$f;\
							if [ $$? -eq 0 ]; then\
								if [ $(DEBUG) != 0 ]; then\
									echo $(RM) $$f;\
								fi;\
								$(RM) $$f;\
							fi;\
							break;\
						fi;\
					done;\
				fi;\
			fi;\
		done;\
	fi

