# SNiFF+ - Makefile configuration for Linux 1.0

SYSTEM = Unix

# some shell commands
SHELL = /bin/sh
RM = rm -f
RM_INTACT = rm -i
MV = mv
MK_DIR = mkdir -p
MK_SYMLINK = ln -s
CP = cp

# path delimiter characters
CLASSPATH_DELIMITER = :
D = :
DEVNULL = /dev/null
# parameters for native make
MAKE_PARAMS = $(JOBS)
 
# general make command
OWN_MAKE = $(MAKE) $(MAKE_PARAMS)
SYSTYPE   = -DOS_SYSV -DOS_LINUX -DOS_LINUX_1_0 -D__GLIBC__=2
 
OS_CXXFLAGS = $(SYSTYPE)
OS_CFLAGS   = $(SYSTYPE)
OS_YACCFLAGS =
OS_LEXFLAGS = 
OS_IDLFLAGS = $(SYSTYPE)
OS_FFLAGS = $(SYSTYPE)
OS_JFLAGS =
OS_JARFLAGS =
OS_PURIFYFLAGS =
OS_QUANTIFYFLAGS =

#
# C++ compiler
#
CXX = gcc
CXXFLAGS = -g
OVERALL_OPTION_CXX = -c

#
# C compiler
#
CC = gcc
CFLAGS   = -g
OVERALL_OPTION_CC = -c

# program for linking an executable
LINK = gcc -ldl
# platform specific library
OS_LIBS =

# program for linking relocatable object files
LD = ld -r -m elf_i386
LDFLAGS  = 

LD_SHARED = $(CXX)
LD_SHAREDFLAGS  = -shared

AR = ar
ARFLAGS = rv
RANLIB = ranlib

#
# yacc compiler
#
YACC = bison
YACCFLAGS = -yd
YACC_CFILE_SUFFIX = C

#
# lexical analysis program generator
#
LEX  = flex
LEXFLAGS =
LEX_CFILE_SUFFIX = c

#
# fortran compiler
#
FC  = f77
FFLAGS =
OVERALL_OPTION_FC = -c

#
# java compiler
#
JAVAC  = javac
JAVA_DEPEND_FLAG = -depend
JFLAGS =
JAR = jar
JARFLAGS = -cvf
JAVA_INTERPRETER = java
JAVA_APPLET_VIEWER = appletviewer

#
#	Purify
#
PURIFYFLAGS = 
PURIFY = purify
 
#
#	Quantify
#
QUANTIFYFLAGS = 
QUANTIFY = quantify
 
# X11 include files and library
X11_INCL = 
X11_LIB  = -L/usr/X11R6/lib -lX11

# socket libraries
SOCKET_LIBS = 

#
# IDL
#
# orbix installation directory
IDL_DIR		= /orbix

# binary, library and include directories
IDL_BINDIR    = $(IDL_DIR)/bin
IDL_LIBDIR    = $(IDL_DIR)/lib
IDL_INCDIR    = $(IDL_DIR)/include

# IDL compiler
IDL           = $(IDL_BINDIR)/idl
IDLFLAGS      =
IDL_CFILE_SUFFIX = cc

# server and client libraries
IDL_SERVER_LIB = -lITsrv
IDL_CLIENT_LIB = -lITclt

#
# Ilog Broker
#
# Ilog Broker installation directory
ILB_HOME    = $(ILBHOME)
 
# Ilog Broker architecture and C++ compiler
ILB_SYSTEM  = 
 
# binary, library and include directories
ILB_BINDIR    = $(ILB_HOME)/bin/$(ILB_SYSTEM)
ILB_LIBDIR    = $(ILB_HOME)/lib/$(ILB_SYSTEM)
ILB_INCDIR    = $(ILB_HOME)/include
 
# Ilog Broker preprocessor
ILB           = $(ILB_BINDIR)/ilb
ILBFLAGS      = $(ALL_CXXFLAGS) -ilbk
 
# Ilog Broker libraries
ILB_LIBS       = -L$(ILB_LIBDIR) -lvwbroker -lbroker
ILB_XLIB      = -L$(ILB_LIBDIR) -lxtbroker
 
# Ilog View installation directory
ILV_HOME    = $(ILVHOME)
 
# binary, library and include directories
ILV_BINDIR    = $(ILV_HOME)/bin/$(ILB_SYSTEM)
ILV_LIBDIR    = $(ILV_HOME)/lib/$(ILB_SYSTEM)
ILV_INCDIR    = $(ILV_HOME)/include
 
# Ilog View libraries
ILV_LIBS       = -L$(ILV_LIBDIR) -lilvgadgt -lviews -lxviews

#
# UIM/X
#
# UIM/X installation directory
UIMX_DIR		= /uimx
 
# binary, library and include directories
UIMX_BINDIR    = $(UIMX_DIR)/bin
UIMX_LIBDIR    = $(UIMX_DIR)/lib
UIMX_INCL      = -I$(UIMX_DIR)/include
 
# UIM/X code generator
UXCG           = $(UIMX_BINDIR)/uxcgen
UXCGFLAGS      = -a
 
# UIM/X library
UIMX_LIB = -L$(UIMX_LIBDIR) -lux

#
# pro*c/c++
#
PROC            = ${ORACLE_HOME}/bin/proc
PROCFLAGS       = lines=yes code=cpp parse=none cpp_suffix=cpp
PROCEXTENSION   = .cpp
PROCDEBUG       = 0
